//+------------------------------------------------------------------+
//|                                        DebugWindow_TesterLog.mqh |
//+------------------------------------------------------------------+
#define copyright "Copyright  2011, Alexey N. aka meat, nalx@yandex.ru"
#define show_inputs

extern bool TimeColumn_ExpertTime=false;  //       ,      
extern bool AutoClearLog=false;

#import "DebugWindow.dll"
  void Log(string date, string message);

#import "Kernel32.dll"
  int  OpenFile(string lpFileName,int lpReOpenBuff[],int uStyle);
  bool CloseHandle(int hObject);
  bool ReadFile(int hFile,string lpBuffer,int nNumberOfBytesToRead,int lpNumberOfBytesRead[],int lpOverlapped);
  int GetFileSize(int hFile,int lpFileSizeHigh);
  int SetFilePointer(int hFile,int lDistanceToMove,int lpDistanceToMoveHigh,int dwMoveMethod);

#import
 
//------------------------

int deinit()
{
  Comment("");
}

// ------------------------------------

int start()
{
  int h=-1;
  string FileDateString="";
  string rowstring="";
  int    lastprinttime=0;
  ClearLog();
  Comment(WindowExpertName()," working...");
  
  while(!IsStopped())
  {
    if (CheckFileRefresh(h,FileDateString)==false)  //   ,   
      { Sleep(50); continue; }
    if (AutoClearLog && TimeLocal()-lastprinttime>1)
      ClearLog();
    //int startticks=GetTickCount();
    //int count=0;
    while(ReadNewString(h,rowstring)==true)
    {
      string timestr, message;
      if (TimeColumn_ExpertTime)
      {
        timestr=StringSubstr(rowstring,9,16);
        if (TimeToStr(StrToTime(timestr))!=timestr)  //   
          { message=StringSubstr(rowstring,9); timestr=""; }
         else
           message=StringSubstr(rowstring,27);  //9+16+2
      }
      else
      {
        timestr=FileDateString+"  "+StringSubstr(rowstring,0,8);
        message=StringSubstr(rowstring,9);
      }
      Log(timestr,message);
      rowstring="";
      lastprinttime=TimeLocal();
      //count++;
    }
    //Alert(" : ",count,"  : ",GetTickCount()-startticks," ms"); 
  }
  
  if (h>=0)
    CloseHandle(h);
}

//----------------------------------------

void ClearLog()  
{
  Log("", "Log.Delete.All");  //  
}

//-----------------------------------------

bool CheckFileRefresh(int& h, string& FileDateString)
{
  static string FileName="";
  static int    LastFileSize=0;
    
  if (h>=0)
  {
    int filesize=GetFileSize(h,0);
    if (filesize>LastFileSize)  //   
      { LastFileSize=filesize; return(1); }
  } 
  int time=TimeLocal();
  int timestr=TimeYear(time)*10000+TimeMonth(time)*100+TimeDay(time);
  string path=TerminalPath()+"\\tester\\logs\\";
  string filename=path+timestr+".log";
   
  if (filename==FileName) return(0);
    
  if (h>=0) if (!CloseHandle(h)) Print("      ",filename);
  int buffer[34];  //136 
  h=OpenFile(filename,buffer,0);  // 0 = OF_READ
  if (h<0)
  { 
    int error=buffer[0]/0xFFFF;
    if (error==2) return(0);  // ERROR_FILE_NOT_FOUND
    static string last_try_filename="";
    if (filename!=last_try_filename) Print("     ",filename," ( ",error,")");
    last_try_filename=filename;
    return(0);
  }
  Print("  ",filename);
  FileName=filename;
  FileDateString=TimeToStr(TimeLocal(),TIME_DATE);
  LastFileSize=GetFileSize(h,0);
    
  static bool FirstStart=true;
  if (!FirstStart) return(1);
    
  SetFilePointer(h,0,0,2); // 2 = FILE_END
  FirstStart=0;
  return(0);
}
  
//----------------------------------------

bool ReadNewString(int h, string& resultstr)
{
  string strbuf=" ";
  int readcount[1];
  bool readcomplete=0;
  while (!IsStopped())
  {
    if (!ReadFile(h,strbuf,1,readcount,0)) break;
    if (readcount[0]==0) break;
    if (strbuf=="\r") continue;
    if (strbuf=="\n") { readcomplete=true; break; }
    resultstr=resultstr+strbuf;
  }
  if (readcomplete) return(true);
  return(0);
}